
GameBackgroundLayer = class("GameBackgroundLayer",function()
    return cc.Layer:create()
end)
GameBackgroundLayer.__index = GameBackgroundLayer

function GameBackgroundLayer:ctor()
   local cache = cc.SpriteFrameCache:getInstance()
   cache:addSpriteFrames("bg/bg.plist", "bg/bg.png")

   self.allBackGrounds = {}
   self.height = 960
   self:createBgs()
   
end


function GameBackgroundLayer:createBgs()

	local bg0 = cc.Sprite:createWithSpriteFrameName("bg_0.png");
	local bg1 = cc.Sprite:createWithSpriteFrameName("bg_1.png");

	self:addChild(bg0)
	self:addChild(bg1)

	bg0:setScale(2.02)
	bg1:setScale(2.02)

	bg0:getTexture():setAliasTexParameters()
	bg1:getTexture():setAliasTexParameters()


	table.insert(self.allBackGrounds, bg0)
	table.insert(self.allBackGrounds, bg1)

    local startPositionX = GameUtil:VISIBLE_WIDTH() * 0.5
    local eachBgHeight = self.height
    local startPositionY = eachBgHeight * 0.5
    
	bg0:setPosition(startPositionX, startPositionY)

	startPositionY = startPositionY + eachBgHeight
	bg1:setPosition(startPositionX, startPositionY)

	
end


function GameBackgroundLayer:getFirstBgTop()
	return (self.allBackGrounds[1]:getPositionY()  + self.height * 0.5)
end

function GameBackgroundLayer:moveFirstBgToLast()
	local firstBg = self.allBackGrounds[1]
	table.remove(self.allBackGrounds, 1)
	table.insert(self.allBackGrounds, firstBg)
	firstBg:setPositionY(self.allBackGrounds[#(self.allBackGrounds) - 1]:getPositionY() + self.height)
end