

GameObjectsLayer = class("GameObjectsLayer",function()
    return cc.Layer:create()
end)
GameObjectsLayer.__index = GameObjectsLayer

g_GameObjectsLayer = nil

function GameObjectsLayer:ctor()
    g_GameObjectsLayer = self


    self:registerScriptHandler(function(tag)
        if "enter" == tag then
            --self:onEnter()
        elseif "exit" == tag then
            self:onExit()
        end
    end)
    self:init()
end

function GameObjectsLayer:onExit()
    if(self._camera ~= nil)then
       self._camera = nil
    end

end


function GameObjectsLayer:init()

    self:createHero()

    if self._camera == nil then
        self._camera = cc.Camera:createOrthographic(GameUtil:VISIBLE_WIDTH(), GameUtil:VISIBLE_HEIGHT(), 0, 1)
        self._camera:setCameraFlag(cc.CameraFlag.USER1)
        self:addChild(self._camera)
        self._camera:setPosition3D(cc.vec3(0, 0, 0))
    end
    
    self:setCameraMask(2)

end

function GameObjectsLayer:update(dt)
    if(self.isPause == true)then
        return nil
    end

    local moveDistance = 525 * dt
    
    self.hero:setPositionY(self.hero:getPositionY() + moveDistance)

    self._camera:setPositionY(self.hero:getPositionY() - 180)

    if(self._camera:getPositionY() >= g_GameMainLayer.backgroundLayer:getFirstBgTop())then
        g_GameMainLayer.backgroundLayer:moveFirstBgToLast()
    end

 
end

function GameObjectsLayer:pause()
    self.isPause = true
end

function GameObjectsLayer:continue()
    self.isPause = false
end

function GameObjectsLayer:createHero()
    self.hero = Hero.new()
    self:addChild(self.hero, 1)
    self.hero:setPosition(cc.p(GameUtil:VISIBLE_WIDTH() * 0.5, 180))
end









